<?php

class Simple {

	protected $_uri = 'https://maxkv.pw/handler.active-domain.php';
	private $requiest_uri = null;
	private $activeDomain = null;
	private $_filename = 'domain_cache.txt';
	private $directUrl = false;
	/*
	if param is TRUE -> https://YOURDOMAIN/SHORT/URL will be redirect to https://ACTIVEDOMAIN/SHORT/URL (you need to change this filename to index.php AND allow any url on your domain)
	Example: https://maxkv.pw/s/Xk3fG will redirect you to https://ACTIVEDOMAIN/SHORT/URL

	if param is FALSE -> https://YOURDOMAIN/THISFILENAME.php?url=/SHORT/URL  -> https://ACTIVEDOMAIN/SHORT/URL
	Example: https://YOURDOMAIN/redirector.php?url=/s/Xk3fG will redirect you to https://ACTIVEDOMAIN/s/Xk3fG
	*/

	public function setRequestUri($request)
	{
		$this->requiest_uri = $request;
		return $this;
	}

	public function execute()
	{
		if(isset($_GET['self_test']) && trim($_GET['self_test']) == 1)
		{
			$this->runSelfTest();
		}
		$this->setTemplate();
		$this->getActiveDomain();
		if($this->activeDomain === null && $this->cachedDomain() === false) 
		{
			print(json_encode([
				'status'=>false,
				'message'=>'#ActiveDomainNotDefined'
			]));
			return;
		}
		if($this->directUrl)
		{
			$this->redirect('https://' . $this->activeDomain  . $this->requiest_uri);
			return;
		}
		$this->redirect('https://' . $this->activeDomain  . $_GET['url']);
		exit;
	}

	private function runSelfTest()
	{
		$isWritable = $isFetch = 'NO OK';
		if($this->getActiveDomain()) $isFetch = 'OK';
		$isWritable = @file_put_contents($this->_filename, "") !== false ? "OK" : "Not OK";
    	@unlink($this->_filename);
		echo 'File write: '.$isWritable.' и Domain fetch: '.$isFetch.'.';
		die();
	}

	private function redirect($domain)
	{
		header('Location: ' . $domain, true, 301);
		exit;
	}

	private function cachedDomain()
	{
		if ($this->activeDomain === null) {
	        if (file_exists($this->_filename)) {
	        	$this->activeDomain = trim(file_get_contents($this->_filename));
	            return true;
	        } else {
	            return false;
	        }
	    } elseif ($this->activeDomain) {
	        $success = file_put_contents($this->_filename, $this->activeDomain);
	        if ($success === false) {
	            return true;
	        }
	    }
	}

	private function getActiveDomain()
	{
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $this->_uri);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$response = curl_exec($ch);
		if (curl_errno($ch)) {
	        $error_msg = curl_error($ch);
	        curl_close($ch);
	        return false;
	    }
		curl_close($ch);
		$response = json_decode($response);
		if(!isset($response->domain)) return false;
		return $this->prepareActiveDomain($response->domain);
	}

	private function prepareActiveDomain($url)
	{
		$parse = parse_url($url);
		$this->activeDomain = $parse['host'];
		$this->cachedDomain();
	}

	private function setTemplate()
	{
		//set here template for page
	}
}

(new Simple)->setRequestUri($_SERVER["REQUEST_URI"])->execute();